(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser'), require('rxjs'), require('@angular/router'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@anjuna/angular-docs', ['exports', '@angular/core', '@angular/platform-browser', 'rxjs', '@angular/router', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory((global.anjuna = global.anjuna || {}, global.anjuna['angular-docs'] = {}), global.ng.core, global.ng.platformBrowser, global.rxjs, global.ng.router, global.rxjs.operators, global.ng.common));
}(this, (function (exports, core, platformBrowser, rxjs, router, operators, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var DocsService = /** @class */ (function () {
        function DocsService() {
            this._menuItems$ = new rxjs.BehaviorSubject(null);
        }
        Object.defineProperty(DocsService.prototype, "menuItems$", {
            get: function () {
                return this._menuItems$.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DocsService.prototype, "menuItems", {
            set: function (items) {
                this._menuItems = items;
                this._menuItems$.next(items);
            },
            enumerable: true,
            configurable: true
        });
        DocsService.ɵprov = core.ɵɵdefineInjectable({ factory: function DocsService_Factory() { return new DocsService(); }, token: DocsService, providedIn: "root" });
        DocsService = __decorate([
            core.Injectable({ providedIn: 'root' })
        ], DocsService);
        return DocsService;
    }());

    var baseTitle = function (title) {
        return title.includes('|') ? title.split(' | ')[0] : title;
    };
    var titleFromName = function (name) {
        return name.split(/(?=[A-Z])/).join(' ');
    };
    var titleFromTag = function (tag) {
        return tag.split('-').slice(1).map(function (word) { return word.charAt(0).toUpperCase() + word.slice(1); }).join(' ');
    };

    var ApiComponent = /** @class */ (function () {
        function ApiComponent(title, service) {
            this.title = title;
            this.service = service;
            this.service.menuItems = undefined;
            this.title.setTitle(baseTitle(this.title.getTitle()) + " | API");
        }
        ApiComponent.ctorParameters = function () { return [
            { type: platformBrowser.Title },
            { type: DocsService }
        ]; };
        ApiComponent = __decorate([
            core.Component({
                template: '<router-outlet></router-outlet>',
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __metadata("design:paramtypes", [platformBrowser.Title, DocsService])
        ], ApiComponent);
        return ApiComponent;
    }());


    (function (FrameworkType) {
        FrameworkType["angular"] = "angular";
        FrameworkType["javascript"] = "javascript";
        FrameworkType["vue"] = "vue";
    })(exports.FrameworkType || (exports.FrameworkType = {}));
    var DEMO_COMPONENTS = new core.InjectionToken('Demo components');
    var GET_STARTED_URL = new core.InjectionToken('URL to get started from home');
    var HOME_README = new core.InjectionToken('Injectable Home Readme');
    var LIBRARY_API = new core.InjectionToken('The full library API');
    var MODULE_DOCS = new core.InjectionToken('Demo components');
    var MODULE_GET_STARTED_URL = new core.InjectionToken('URL to try a module');
    var MODULE_NAME = new core.InjectionToken('Module name');
    var MODULE_README = new core.InjectionToken('Injectable Web Components Readme');
    var MODULE_TYPE = new core.InjectionToken('The framework the module is for');

    var ApiDocComponent = /** @class */ (function () {
        function ApiDocComponent(title, route, api) {
            var _this = this;
            this.title = title;
            this.route = route;
            var module = this.route.snapshot.paramMap.get('module');
            this.id = this.route.snapshot.paramMap.get('id');
            this.doc = api[module].find(function (d) { return d.tag ? d.tag === _this.id : d.name === _this.id; });
            this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + this.id);
        }
        ApiDocComponent.ctorParameters = function () { return [
            { type: platformBrowser.Title },
            { type: router.ActivatedRoute },
            { type: undefined, decorators: [{ type: core.Inject, args: [LIBRARY_API,] }] }
        ]; };
        ApiDocComponent = __decorate([
            core.Component({
                template: "<article class=\"component-readme\">\n    <div class=\"breadcrumbs\">\n        <a [routerLink]=\"['../../']\">API</a><span class=\"sep\">/</span><span class=\"id\">{{id}}</span>\n    </div>\n    <ad-markdown [data]=\"doc.readme\"></ad-markdown>\n    <ad-api [doc]=\"doc\"></ad-api>\n</article>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                styles: [":host{display:block}:host .breadcrumbs{margin-bottom:1rem}:host .breadcrumbs .sep{color:var(--anj-border-dark);margin:0 .5rem}:host .breadcrumbs .id{color:var(--anj-neutral)}"]
            }),
            __param(2, core.Inject(LIBRARY_API)),
            __metadata("design:paramtypes", [platformBrowser.Title, router.ActivatedRoute, Object])
        ], ApiDocComponent);
        return ApiDocComponent;
    }());

    var ApiListComponent = /** @class */ (function () {
        function ApiListComponent(api) {
            this.api = api;
            this.filtered = this.api;
        }
        ApiListComponent.prototype.filter = function (_a) {
            var _this = this;
            var detail = _a.detail;
            var query = detail.value.toLowerCase();
            var filtered = {};
            for (var module in this.api) {
                if (this.api.hasOwnProperty(module)) {
                    var mFiltered = this.api[module].filter(function (d) { return _this.nameFromDoc(d).toLowerCase().includes(query); });
                    if (mFiltered.length > 0) {
                        filtered[module] = mFiltered;
                    }
                }
            }
            this.filtered = Object.keys(filtered).length > 0 ? filtered : undefined;
        };
        ApiListComponent.prototype.apiPath = function (module, doc) {
            return module + "/" + this.nameFromDoc(doc);
        };
        ApiListComponent.prototype.nameFromDoc = function (doc) {
            return doc.tag ? doc.tag : doc.name;
        };
        ApiListComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [LIBRARY_API,] }] }
        ]; };
        ApiListComponent = __decorate([
            core.Component({
                template: "<anj-form-group>\n    <anj-filter placeholder=\"Search\" (anjFilter)=\"filter($event)\"></anj-filter>\n</anj-form-group>\n<ng-container *ngIf=\"filtered; else noResults\">\n    <section *ngFor=\"let lib of filtered | keyvalue\">\n        <anj-headline><h3>{{lib.key}}</h3></anj-headline>\n        <div class=\"row results-container\">\n            <div *ngFor=\"let doc of lib.value\" class=\"col-12 col-sm-6 col-md-4 col-lg-3 result\">\n                <a [routerLink]=\"apiPath(lib.key, doc)\">{{nameFromDoc(doc)}}</a>\n            </div>\n        </div>\n    </section>\n</ng-container>\n<ng-template #noResults>\n    <p>No matches found.</p>\n</ng-template>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                styles: [":host{display:block}:host anj-headline{border-bottom:1px solid var(--anj-border);padding-bottom:.75rem;margin-bottom:1rem}:host .results-container{margin-bottom:2rem}:host .result{margin-bottom:.5rem}"]
            }),
            __param(0, core.Inject(LIBRARY_API)),
            __metadata("design:paramtypes", [Object])
        ], ApiListComponent);
        return ApiListComponent;
    }());

    var LIBRARY_VERSION = new core.InjectionToken('LibraryVersion');
    var VersionPipe = /** @class */ (function () {
        function VersionPipe(version) {
            this.version = version;
        }
        VersionPipe.prototype.transform = function (value) {
            if (!this.version) {
                return value;
            }
            var val = value.default ? value.default : value;
            return val.replace(/0.0.0/g, this.version);
        };
        VersionPipe.ctorParameters = function () { return [
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [LIBRARY_VERSION,] }] }
        ]; };
        VersionPipe = __decorate([
            core.Pipe({
                name: 'version'
            }),
            __param(0, core.Optional()), __param(0, core.Inject(LIBRARY_VERSION)),
            __metadata("design:paramtypes", [String])
        ], VersionPipe);
        return VersionPipe;
    }());

    var ExternalDocComponent = /** @class */ (function () {
        function ExternalDocComponent(docs, route, version) {
            var _this = this;
            this.docs = docs;
            this.route = route;
            this.version = version;
            this.doc$ = this.route.paramMap.pipe(operators.switchMap(function (params) { return rxjs.of(version.transform(_this.docs[params.get('id')])); }));
        }
        ExternalDocComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [MODULE_DOCS,] }] },
            { type: router.ActivatedRoute },
            { type: VersionPipe }
        ]; };
        ExternalDocComponent = __decorate([
            core.Component({
                template: '<ad-markdown [data]="doc$ | async"></ad-markdown>',
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __param(0, core.Inject(MODULE_DOCS)),
            __metadata("design:paramtypes", [Object, router.ActivatedRoute, VersionPipe])
        ], ExternalDocComponent);
        return ExternalDocComponent;
    }());

    var ExternalModuleComponent = /** @class */ (function () {
        function ExternalModuleComponent(docs, name, service) {
            this.docs = docs;
            this.name = name;
            this.service = service;
            var path = name.toLowerCase();
            this.service.menuItems = Object.keys(docs).map(function (doc) {
                return {
                    link: path + "/" + doc,
                    name: doc.split('-').join(' ')
                };
            });
        }
        ExternalModuleComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [MODULE_DOCS,] }] },
            { type: String, decorators: [{ type: core.Inject, args: [MODULE_NAME,] }] },
            { type: DocsService }
        ]; };
        ExternalModuleComponent = __decorate([
            core.Component({
                template: '<router-outlet></router-outlet>',
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __param(0, core.Inject(MODULE_DOCS)), __param(1, core.Inject(MODULE_NAME)),
            __metadata("design:paramtypes", [Object, String, DocsService])
        ], ExternalModuleComponent);
        return ExternalModuleComponent;
    }());

    var FeatureComponent = /** @class */ (function () {
        function FeatureComponent(route, changeRef, title, docs, frameWorkType) {
            var _this = this;
            this.route = route;
            this.changeRef = changeRef;
            this.title = title;
            this.docs = docs;
            this.frameWorkType = frameWorkType;
            this.route.params.subscribe({
                next: function (params) {
                    var doc = _this.docs.find(function (d) {
                        return d.tag ? d.tag === params.id : d.name === params.id;
                    });
                    _this.doc = _this.filterExamples(doc);
                    _this.title.setTitle(_this.titleFromDoc(_this.title.getTitle()));
                    _this.changeRef.markForCheck();
                }
            });
        }
        FeatureComponent.prototype.sortedKeys = function (usages) {
            var keys = Object.keys(usages);
            var firstIndex = keys.findIndex(function (k) { return k === 'usage' || k === 'angular' || k === 'vue'; });
            return keys.splice(firstIndex, 1).concat(keys);
        };
        FeatureComponent.prototype.titleFromDoc = function (title) {
            var base = baseTitle(title);
            if (!this.doc) {
                return base;
            }
            return base + " | " + (this.doc.tag ? titleFromTag(this.doc.tag) : titleFromName(this.doc.name));
        };
        FeatureComponent.prototype.filterExamples = function (doc) {
            if (this.frameWorkType === exports.FrameworkType.angular) {
                return this.getNgExamples(doc);
            }
            else if (this.frameWorkType === exports.FrameworkType.vue) {
                return this.getVueExamples(doc);
            }
            else if (this.frameWorkType === exports.FrameworkType.javascript) {
                return this.getJsExamples(doc);
            }
            return doc;
        };
        // Return ng examples, if existing. Otherwise, js examples.
        FeatureComponent.prototype.getNgExamples = function (doc) {
            var usages = {};
            if (doc.usage.angular) {
                for (var u in doc.usage) {
                    if (u === 'angular' || u.startsWith('ng-')) {
                        usages[u] = doc.usage[u];
                    }
                }
                doc.usage = usages;
                return doc;
            }
            else {
                return this.getJsExamples(doc);
            }
        };
        // Return js examples.
        FeatureComponent.prototype.getJsExamples = function (doc) {
            var usages = {};
            for (var u in doc.usage) {
                if (u !== 'angular' && !u.startsWith('ng-') &&
                    u !== 'vue' && !u.startsWith('vue-')) {
                    usages[u] = doc.usage[u];
                }
            }
            doc.usage = usages;
            return doc;
        };
        // Return vue examples, if existing. Otherwise, js examples.
        FeatureComponent.prototype.getVueExamples = function (doc) {
            var usages = {};
            if (doc.usage.vue) {
                for (var u in doc.usage) {
                    if (u === 'vue' || u.startsWith('vue-')) {
                        usages[u] = doc.usage[u];
                    }
                }
                doc.usage = usages;
                return doc;
            }
            else {
                return this.getJsExamples(doc);
            }
        };
        FeatureComponent.ctorParameters = function () { return [
            { type: router.ActivatedRoute },
            { type: core.ChangeDetectorRef },
            { type: platformBrowser.Title },
            { type: Array, decorators: [{ type: core.Inject, args: [MODULE_DOCS,] }] },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MODULE_TYPE,] }] }
        ]; };
        FeatureComponent = __decorate([
            core.Component({
                template: "<div class=\"row\">\n    <div [ngClass]=\"doc.usage ? 'col-12 col-lg-10' : 'col-12'\">\n        <article class=\"component-readme\" id=\"overview\">\n            <ad-markdown [data]=\"doc.readme\"></ad-markdown>\n        </article>\n        <article *ngFor=\"let key of sortedKeys(doc.usage)\" id=\"{{key}}\">\n            <ad-use-case [usage]=\"doc.usage[key]\"></ad-use-case>\n        </article>\n        <ad-api [doc]=\"doc\"></ad-api>\n    </div>\n    <div *ngIf=\"doc.usage\" class=\"d-none d-lg-flex col-lg-2 toc-wrapper\">\n        <ad-toc [docs]=\"doc.usage\" [keys]=\"sortedKeys(doc.usage)\"></ad-toc>\n    </div>\n</div>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                styles: [".component-readme{margin-bottom:2.5rem}"]
            }),
            __param(3, core.Inject(MODULE_DOCS)),
            __param(4, core.Optional()), __param(4, core.Inject(MODULE_TYPE)),
            __metadata("design:paramtypes", [router.ActivatedRoute,
                core.ChangeDetectorRef,
                platformBrowser.Title, Array, String])
        ], FeatureComponent);
        return FeatureComponent;
    }());

    var HomeComponent = /** @class */ (function () {
        function HomeComponent(title, service, getStartedUrl, readme) {
            this.title = title;
            this.service = service;
            this.getStartedUrl = getStartedUrl;
            this.readme = readme;
            this.service.menuItems = null;
            this.title.setTitle(baseTitle(this.title.getTitle()));
        }
        HomeComponent.ctorParameters = function () { return [
            { type: platformBrowser.Title },
            { type: DocsService },
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [GET_STARTED_URL,] }] },
            { type: String, decorators: [{ type: core.Inject, args: [HOME_README,] }] }
        ]; };
        HomeComponent = __decorate([
            core.Component({
                template: "<article>\n    <ad-markdown [data]=\"readme\"></ad-markdown>\n    <p *ngIf=\"getStartedUrl\" class=\"text-center pt-4\">\n        <anj-button [routerLink]=\"getStartedUrl\">Get Started</anj-button>\n    </p>\n</article>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush
            }),
            __param(2, core.Optional()), __param(2, core.Inject(GET_STARTED_URL)),
            __param(3, core.Inject(HOME_README)),
            __metadata("design:paramtypes", [platformBrowser.Title,
                DocsService, String, String])
        ], HomeComponent);
        return HomeComponent;
    }());

    var IntroComponent = /** @class */ (function () {
        function IntroComponent(title, readme, moduleName, getStartedUrl) {
            this.title = title;
            this.readme = readme;
            this.moduleName = moduleName;
            this.getStartedUrl = getStartedUrl;
            this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + moduleName);
        }
        IntroComponent.ctorParameters = function () { return [
            { type: platformBrowser.Title },
            { type: String, decorators: [{ type: core.Inject, args: [MODULE_README,] }] },
            { type: String, decorators: [{ type: core.Inject, args: [MODULE_NAME,] }] },
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MODULE_GET_STARTED_URL,] }] }
        ]; };
        IntroComponent = __decorate([
            core.Component({
                selector: 'ad-components',
                template: "<article>\n    <ad-markdown [data]=\"readme | version\"></ad-markdown>\n    <p *ngIf=\"getStartedUrl\" class=\"text-center pt-4\">\n        <anj-button [routerLink]=\"getStartedUrl\">Try It</anj-button>\n    </p>\n</article>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                styles: [":host::ng-deep ad-markdown p[align=center]{display:none}"]
            }),
            __param(1, core.Inject(MODULE_README)),
            __param(2, core.Inject(MODULE_NAME)),
            __param(3, core.Optional()), __param(3, core.Inject(MODULE_GET_STARTED_URL)),
            __metadata("design:paramtypes", [platformBrowser.Title, String, String, String])
        ], IntroComponent);
        return IntroComponent;
    }());

    var JsDemo = /** @class */ (function () {
        function JsDemo(element, demo) {
            element.nativeElement.appendChild(document.createRange().createContextualFragment(demo));
        }
        return JsDemo;
    }());

    var UseCaseComponent = /** @class */ (function () {
        function UseCaseComponent(sanitizer) {
            this.sanitizer = sanitizer;
        }
        UseCaseComponent.prototype.ngOnChanges = function () {
            var docs = this.usage.split('<!-- Demo -->');
            this.doc = docs[0].trim();
            this.demo = docs[1] ? this.sanitizer.bypassSecurityTrustHtml(docs[1] ? docs[1].trim() : '') : undefined;
            if (docs[2]) {
                var tabs_1 = {};
                docs[2].trim().split('```').forEach(function (s) {
                    s = s.trim();
                    if (s) {
                        tabs_1[s.split(/\n/)[0].trim()] = "" + '```' + s + '```';
                    }
                });
                this.tabs = tabs_1;
            }
        };
        UseCaseComponent.prototype.switchTabs = function (tab) {
            this.activeTab = tab ? tab : this.activeTab ? undefined : Object.keys(this.tabs)[0];
        };
        UseCaseComponent.prototype.getTitle = function (doc) {
            return doc.split('\n')[0].replace(/#/g, '').trim();
        };
        UseCaseComponent.prototype.codeType = function (type) {
            return type.includes('typescript') ? 'ts' : type;
        };
        UseCaseComponent.ctorParameters = function () { return [
            { type: platformBrowser.DomSanitizer }
        ]; };
        __decorate([
            core.Input(),
            __metadata("design:type", String)
        ], UseCaseComponent.prototype, "usage", void 0);
        UseCaseComponent = __decorate([
            core.Component({
                selector: 'ad-use-case',
                template: "<ad-markdown [data]=\"doc\"></ad-markdown>\n<anj-card *ngIf=\"demo\" elevation=\"1\">\n    <anj-card-header>\n        <anj-headline>\n            <h3>{{getTitle(doc)}}</h3>\n            <anj-button context=\"icon\" (click)=\"switchTabs()\" title=\"View Source\">\n                <svg slot=\"icon-only\" xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" viewBox=\"0 0 24 24\">\n                    <path d=\"M9.4 16.6L4.8 12l4.6-4.6L8 6l-6 6 6 6 1.4-1.4zm5.2 0l4.6-4.6-4.6-4.6L16 6l6 6-6 6-1.4-1.4z\"/>\n                </svg>\n            </anj-button>\n        </anj-headline>\n    </anj-card-header>\n    <anj-card-body>\n        <div class=\"example-container\" [class.anj-active]=\"activeTab\">\n            <anj-tabs>\n                <anj-tab *ngFor=\"let t of tabs | keyvalue\" (click)=\"switchTabs(t.key)\" [class.anj-active]=\"t.key === activeTab\">{{codeType(t.key)}}</anj-tab>\n            </anj-tabs>\n            <div class=\"example\">\n                <ad-markdown *ngFor=\"let t of tabs | keyvalue\" [data]=\"t.value\" [class.anj-active]=\"t.key === activeTab\"></ad-markdown>\n            </div>\n        </div>\n        <div *ngIf=\"demo\" class=\"demo-container\" [innerHTML]=\"demo\"></div>\n    </anj-card-body>\n</anj-card>\n",
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                styles: [":host{border-bottom:1px solid var(--anj-border);display:block;margin-bottom:3rem;padding-bottom:3.5rem}:host anj-card{margin-top:2rem}:host anj-tab{text-transform:uppercase}:host .example-container{margin:0 -1.25rem}:host .example-container:not(.anj-active){height:0;overflow:hidden}:host .example{background-color:var(--anj-background);border-bottom:1px solid var(--anj-border);margin:0 0 1rem;padding:1rem}:host .example ad-markdown{display:none}:host .example ad-markdown.anj-active{display:block}"]
            }),
            __metadata("design:paramtypes", [platformBrowser.DomSanitizer])
        ], UseCaseComponent);
        return UseCaseComponent;
    }());

    var AnjunaDocsModule = /** @class */ (function () {
        function AnjunaDocsModule() {
        }
        AnjunaDocsModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    router.RouterModule
                ],
                declarations: [
                    ApiComponent,
                    ApiDocComponent,
                    ApiListComponent,
                    ExternalDocComponent,
                    ExternalModuleComponent,
                    FeatureComponent,
                    HomeComponent,
                    IntroComponent,
                    UseCaseComponent,
                    VersionPipe
                ],
                exports: [
                    ApiComponent,
                    ApiDocComponent,
                    ApiListComponent,
                    ExternalDocComponent,
                    ExternalModuleComponent,
                    FeatureComponent,
                    HomeComponent,
                    IntroComponent
                ],
                entryComponents: [
                    ApiComponent,
                    ApiDocComponent,
                    ApiListComponent,
                    FeatureComponent,
                    HomeComponent,
                    IntroComponent
                ],
                providers: [
                    VersionPipe
                ],
                schemas: [
                    core.CUSTOM_ELEMENTS_SCHEMA
                ]
            })
        ], AnjunaDocsModule);
        return AnjunaDocsModule;
    }());

    exports.AnjunaDocsModule = AnjunaDocsModule;
    exports.ApiComponent = ApiComponent;
    exports.ApiDocComponent = ApiDocComponent;
    exports.ApiListComponent = ApiListComponent;
    exports.DEMO_COMPONENTS = DEMO_COMPONENTS;
    exports.DocsService = DocsService;
    exports.ExternalDocComponent = ExternalDocComponent;
    exports.ExternalModuleComponent = ExternalModuleComponent;
    exports.FeatureComponent = FeatureComponent;
    exports.GET_STARTED_URL = GET_STARTED_URL;
    exports.HOME_README = HOME_README;
    exports.HomeComponent = HomeComponent;
    exports.IntroComponent = IntroComponent;
    exports.JsDemo = JsDemo;
    exports.LIBRARY_API = LIBRARY_API;
    exports.LIBRARY_VERSION = LIBRARY_VERSION;
    exports.MODULE_DOCS = MODULE_DOCS;
    exports.MODULE_GET_STARTED_URL = MODULE_GET_STARTED_URL;
    exports.MODULE_NAME = MODULE_NAME;
    exports.MODULE_README = MODULE_README;
    exports.MODULE_TYPE = MODULE_TYPE;
    exports.VersionPipe = VersionPipe;
    exports.baseTitle = baseTitle;
    exports.titleFromName = titleFromName;
    exports.titleFromTag = titleFromTag;
    exports.ɵa = UseCaseComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=anjuna-angular-docs.umd.js.map
